## ghc 9.0.2

=== Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      https://gitlab.haskell.org/ghc/ghc/wikis/building/architecture
#      https://gitlab.haskell.org/ghc/ghc/wikis/building/modifying
#
# -----------------------------------------------------------------------------

# Eliminate use of the built-in implicit rules, and clear out the default list
# of suffixes for suffix rules. Speeds up make quite a bit. Both are needed
# for the shortest `make -d` output.
# Don't set --no-builtin-variables; some rules might stop working if you do
# (e.g. 'make clean' in testsuite/ currently relies on an implicit $RM).
MAKEFLAGS += --no-builtin-rules
.SUFFIXES:


# -----------------------------------------------------------------------------
# Sanitize environment

# See #11530
export GREP_OPTIONS :=

ifneq "$(filter maintainer-clean distclean clean clean_% help,$(MAKECMDGOALS))" ""
-include mk/config.mk
else
include mk/config.mk
ifeq "$(ProjectVersion)" ""
$(error Please run ./configure first)
endif
endif

include mk/custom-settings.mk


ifeq "$(wildcard distrib/)" ""

# We're in a bindist

.PHONY: default
default:
	@echo 'Run "make install" to install'
	@false

.PHONY: install show
install show:
	$(MAKE) --no-print-directory -f ghc.mk $@ BINDIST=YES NO_INCLUDE_DEPS=YES

# Note [install-strip]
#
# install-strip is like install, but it strips the executable files while
# installing them.
#
# From http://www.gnu.org/prep/standards/html_node/Standard-Targets.html:
#
#   "install-strip should not strip the executables in the build directory
#   which are being copied for installation. It should only strip the copies
#   that are installed. "

.PHONY: install-strip
install-strip:
	# See Note [install-strip].
	$(MAKE) --no-print-directory -f ghc.mk INSTALL_PROGRAM='$(INSTALL_PROGRAM) -s' install BINDIST=YES NO_INCLUDE_DEPS=YES

else

.PHONY: default
default : all
	@:

# For help, type 'make help'
.PHONY: help
help:
	@cat MAKEHELP.md

# No need to update makefiles for these targets:
# (the ones we're filtering out)
REALGOALS=$(filter-out \
    binary-dist \
    binary-dist-prep \
    install-strip \
    sdist sdist-ghc \
    sdist-ghc-prep \
    sdist-windows-tarballs \
    sdist-windows-tarballs-prep \
    sdist-testsuite \
    sdist-testsuite-prep \
    bootstrapping-files \
    framework-pkg \
    clean \
    clean_% \
    distclean \
    maintainer-clean \
    show \
    show! \
    echo \
    help \
    test \
    fulltest \
    slowtest \
    fasttest \
    fast \
  ,$(MAKECMDGOALS))

# configure touches certain files even if they haven't changed.  This
# can mean a lot of unnecessary recompilation after a re-configure, so
# here we cache the old versions of these files so we can restore the
# timestamps.
%.old:  %
	@set -x && test -f $@ && cmp -s $< $@ || cp -p $< $@
	touch -r $@ $<


# NB. not the same as saying '%: ...', which doesn't do the right thing:
# it does nothing if we specify a target that already exists.
.PHONY: $(REALGOALS) all
$(REALGOALS) all: mk/config.mk.old mk/project.mk.old compiler/ghc.cabal.old
ifneq "$(OMIT_PHASE_0)" "YES"
	@echo "===--- building phase 0"
	$(MAKE) --no-print-directory -f ghc.mk phase=0 phase_0_builds
endif
ifneq "$(OMIT_PHASE_1)" "YES"
	@echo "===--- building phase 1"
	$(MAKE) --no-print-directory -f ghc.mk phase=1 phase_1_builds
endif
	@echo "===--- building final phase"
	$(MAKE) --no-print-directory -f ghc.mk phase=final $@

# if BINARY_DIST_DIR is not set, assume we want the old
# behaviour of placing the binary dist into the current
# directory. Provide BINARY_DIST_DIR to put the final
# binary distribution elsewhere.
BINARY_DIST_DIR ?= .

.PHONY: binary-dist
binary-dist: binary-dist-prep
	mv bindistprep/*.tar.$(TAR_COMP_EXT) "$(BINARY_DIST_DIR)"

.PHONY: binary-dist-prep
binary-dist-prep:
ifeq "$(mingw32_TARGET_OS)" "1"
	$(MAKE) --no-print-directory -f ghc.mk windows-binary-dist-prep
else
	rm -f bindist-list
	$(MAKE) --no-print-directory -f ghc.mk bindist-list BINDIST=YES
	$(MAKE) --no-print-directory -f ghc.mk unix-binary-dist-prep
endif

.PHONY: install-strip
install-strip:
	# See Note [install-strip].
	$(MAKE) --no-print-directory -f ghc.mk INSTALL_PROGRAM='$(INSTALL_PROGRAM) -s' install

.PHONY: sdist sdist-ghc sdist-ghc-prep sdist-windows-tarballs sdist-windows-tarballs-prep sdist-testsuite sdist-testsuite-prep
# Just running `./boot && ./configure && make sdist` should work, so skip
# phase 0 and 1 and don't build any dependency files.
sdist sdist-ghc sdist-ghc-prep sdist-windows-tarballs sdist-windows-tarballs-prep sdist-testsuite sdist-testsuite-prep :
	$(MAKE) --no-print-directory -f ghc.mk $@ NO_INCLUDE_DEPS=YES NO_INCLUDE_PKGDATA=YES

.PHONY: clean distclean maintainer-clean
clean distclean maintainer-clean:
	$(MAKE) --no-print-directory -f ghc.mk $@ CLEANING=YES
	test ! -d testsuite || $(MAKE) -C testsuite $@

.PHONY: $(filter clean_%,$(MAKECMDGOALS))
$(filter clean_%, $(MAKECMDGOALS)) : clean_% :
	$(MAKE) --no-print-directory -f ghc.mk $@ CLEANING=YES

.PHONY: bootstrapping-files show echo
bootstrapping-files show echo:
	$(MAKE) --no-print-directory -f ghc.mk $@

.PHONY: show!
show!:
	$(MAKE) --no-print-directory -f ghc.mk show NO_INCLUDE_PKGDATA=YES

ifeq "$(darwin_TARGET_OS)" "1"
.PHONY: framework-pkg
framework-pkg:
	$(MAKE) -C distrib/MacOS $@
endif

# If the user says 'make A B', then we don't want to invoke two
# instances of the rule above in parallel:
.NOTPARALLEL:

endif

# Note [validate and testsuite speed]
#
# There are 3 different validate and testsuite speed settings:
# fast, normal and slow.
#
#                              how    how   used
#           cd tests  config.  many   many  by
# validate  && make   speed=   tests  ways  whom
# =============================================================================
# --fast    fast      2        some   1+exs Travis (to stay within time limit)
# --normal  test      1        all    1+exs Phabricator (slow takes too long?)
# --slow    slow      0        all    all   Nightly (slow is ok)
#
#           accept    1        all    1
#
# `--fast` and `--normal` run one default way, as well as any other ways which
# are explicitly requested by the test using extra_ways().
#
# `make accept` should run all tests exactly once. There is no point in
# accepting a test for multiple ways, since it should produce the same output
# for all ways.
#
# To make sure all .stderr and .stdout files in the testsuite are never
# out-of-date, it is useful if Phabricator, via a normal `./validate` and `make
# test`, runs each test at least once.
.PHONY: fasttest
fasttest:
	$(MAKE) -C testsuite/tests SUMMARY_FILE=../../testsuite_summary.txt fast

.PHONY: test
test:
	$(MAKE) -C testsuite/tests SUMMARY_FILE=../../testsuite_summary.txt

.PHONY: slowtest fulltest
slowtest fulltest:
	$(MAKE) -C testsuite/tests SUMMARY_FILE=../../testsuite_summary.txt slow

.PHONY: fast
fast:
	@echo "You can use 'make fast' only from inside a sub-component directory."
	@exit 1

=== bindisttest/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      https://gitlab.haskell.org/ghc/ghc/wikis/building/architecture
#      https://gitlab.haskell.org/ghc/ghc/wikis/building/modifying
#
# -----------------------------------------------------------------------------

.PHONY: default_target

default_target: all

# Ideally we'd just include something to give us variables
# for paths and arguments to tools etc, and those set in mk/build.mk.
TOP=..
include $(TOP)/mk/tree.mk
include $(TOP)/mk/config.mk

ifeq "$(TEST_PREP)" "YES"
BIN_DIST_TEST_TAR_COMP = ../$(BIN_DIST_PREP_TAR_COMP)
else
BIN_DIST_TEST_TAR_COMP = ../$(BIN_DIST_TAR_COMP)
endif

all:
	"$(RM)" $(RM_OPTS_REC) $(BIN_DIST_INST_SUBDIR)
	"$(RM)" $(RM_OPTS_REC) a/b/c/*
	"$(RM)" $(RM_OPTS) HelloWorld HelloWorld.o HelloWorld.hi output
# We use the a/b/c subdirectory as configure looks for install-sh in
# . .. ../.. and we don't want it to find the build system's install-sh.
#
# NB. tar has funny interpretation of filenames sometimes (thinking
# c:/foo is a remote file), so it's safer to bzip and then pipe into
# tar rather than using tar -xjf:
	cd a/b/c/ && $(TAR_COMP_CMD) -cd ../../../$(BIN_DIST_TEST_TAR_COMP) | $(TAR_CMD) -xf -
ifeq "$(Windows)" "YES"
	mv a/b/c/$(BIN_DIST_NAME) $(BIN_DIST_INST_DIR)
else
	cd a/b/c/$(BIN_DIST_NAME) && ./configure --prefix=$(BIN_DIST_INST_DIR)
	cd a/b/c/$(BIN_DIST_NAME) && $(MAKE) install
endif
	$(BIN_DIST_INST_DIR)/bin/runghc HelloWorld > output
	$(CONTEXT_DIFF) output expected_output
	$(BIN_DIST_INST_DIR)/bin/ghc --make HelloWorld
	./HelloWorld > output
	$(CONTEXT_DIFF) output expected_output
# Without --no-user-package-db we might pick up random packages from ~/.ghc
	$(BIN_DIST_INST_DIR)/bin/ghc-pkg check --no-user-package-db

clean distclean:
	"$(RM)" $(RM_OPTS_REC) $(BIN_DIST_INST_SUBDIR)
	"$(RM)" $(RM_OPTS_REC) a/b/c/*
	"$(RM)" $(RM_OPTS) HelloWorld HelloWorld.o HelloWorld.hi output

# Ignore a load of other standard targets
install install-docs doc:
	@:

show:
	@echo '$(VALUE)="$($(VALUE))"'

=== compiler/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      https://gitlab.haskell.org/ghc/ghc/wikis/building/architecture
#      https://gitlab.haskell.org/ghc/ghc/wikis/building/modifying
#
# -----------------------------------------------------------------------------

# If the user says 'make' or 'make stage=2' here, we behave as if they were
# in the ghc directory instead, so that the executable GHC gets built.
.PHONY: default_to_ghc all_ghc
default_to_ghc : all_ghc

dir = compiler

include ../mk/compiler-ghc.mk

all_ghc :
	+$(TOPMAKE) all_ghc $(EXTRA_MAKE_OPTS)

=== libraries/Cabal/Cabal/Makefile ===
VERSION=3.4.0.0

#KIND=devel
KIND=rc
#KIND=cabal-latest

PREFIX=/usr/local
HC=ghc
GHCFLAGS=-Wall -threaded
SSH_USER=$(USER)

all: build

# build the library itself

SOURCES=Distribution/*.hs Distribution/Simple/*.hs \
	Distribution/PackageDescription/*.hs Distribution/Simple/GHC/*.hs \
	Distribution/Simple/Build/*.hs Distribution/Compat/*.hs \
	Distribution/Simple/Program/*.hs
CONFIG_STAMP=dist/setup-config
BUILD_STAMP=dist/build/libHSCabal-$(VERSION).a
HADDOCK_STAMP=dist/doc/html/Cabal/index.html
USERGUIDE_STAMP=dist/doc/users-guide/index.html
SDIST_STAMP=dist/Cabal-$(VERSION).tar.gz
DISTLOC=dist/release
DIST_STAMP=$(DISTLOC)/Cabal-$(VERSION).tar.gz

# TODO: when we have sphinx-build2 ?
SPHINXCMD:=sphinx-build

COMMA=,

setup: $(SOURCES) Setup.hs
	-mkdir -p dist/setup
	$(HC) $(GHCFLAGS) --make -i. -odir dist/setup -hidir dist/setup Setup.hs \
		-o setup

$(CONFIG_STAMP): setup Cabal.cabal
	./setup configure --with-compiler=$(HC) --prefix=$(PREFIX)

build: $(BUILD_STAMP)
$(BUILD_STAMP): $(CONFIG_STAMP) $(SOURCES)
	./setup build

install: $(BUILD_STAMP)
	./setup install

# documentation...

haddock: $(HADDOCK_STAMP)
$(HADDOCK_STAMP) : $(CONFIG_STAMP) $(BUILD_STAMP)
	./setup haddock

SPHINX_HTML_OUTDIR=dist/doc/users-guide

# do pip install everytime so we have up to date requirements when we build
users-guide: .python-sphinx-virtualenv $(USERGUIDE_STAMP)
$(USERGUIDE_STAMP) : doc/*.rst
	mkdir -p $(SPHINX_HTML_OUTDIR)
	(. ./.python-sphinx-virtualenv/bin/activate && pip install -r doc/requirements.txt && $(SPHINXCMD) doc $(SPHINX_HTML_OUTDIR))

docs: haddock users-guide

.python-sphinx-virtualenv:
	python3 -m venv .python-sphinx-virtualenv
	(. ./.python-sphinx-virtualenv/bin/activate)

clean:
	rm -rf dist/
	rm -f setup

# testing...

moduleTest: tests/ModuleTest.hs tests/PackageDescriptionTests.hs
	mkdir -p dist/test
	$(HC) --make -Wall -DDEBUG -odir dist/test -hidir dist/test \
		-itests tests/ModuleTest.hs -o moduleTest

#tests: moduleTest clean
#	cd tests/A && $(MAKE) clean
#	cd tests/HUnit-1.0 && $(MAKE) clean
#	cd tests/A && $(MAKE)
#	cd tests/HUnit-1.0 && $(MAKE)

#check:
#	rm -f moduleTest
#	$(MAKE) moduleTest
#	./moduleTest

# distribution...

$(SDIST_STAMP) : $(BUILD_STAMP)
	./setup sdist

dist: $(DIST_STAMP)
$(DIST_STAMP) : $(HADDOCK_STAMP) $(USERGUIDE_STAMP) $(SDIST_STAMP)
	rm -rf $(DISTLOC)
	mkdir $(DISTLOC)
	tar -xzf $(SDIST_STAMP) -C $(DISTLOC)/
	mkdir -p $(DISTLOC)/Cabal-$(VERSION)/doc
	cp -r dist/doc/html $(DISTLOC)/Cabal-$(VERSION)/doc/API
	cp -r dist/doc/users-guide $(DISTLOC)/Cabal-$(VERSION)/doc/
	cp ChangeLog.md $(DISTLOC)/Cabal-$(VERSION)/
	tar --format=ustar -C $(DISTLOC) -czf $(DISTLOC)/Cabal-$(VERSION).tar.gz Cabal-$(VERSION)
	mkdir $(DISTLOC)/doc
	mv $(DISTLOC)/Cabal-$(VERSION)/doc/users-guide $(DISTLOC)/doc
	mv $(DISTLOC)/Cabal-$(VERSION)/doc/API $(DISTLOC)/doc
	mv $(DISTLOC)/Cabal-$(VERSION)/ChangeLog.md $(DISTLOC)/
	rm -r $(DISTLOC)/Cabal-$(VERSION)/
	@echo "Cabal tarball built: $(DIST_STAMP)"
	@echo "Release fileset prepared: $(DISTLOC)/"

# Out of date, use SFTP
#release: $(DIST_STAMP)
#	scp -r $(DISTLOC) $(SSH_USER)@haskell.org:/home/web/haskell.org/cabal/release/cabal-$(VERSION)
#	ssh $(SSH_USER)@haskell.org 'cd /home/web/haskell.org/cabal/release && rm -f $(KIND) && ln -s cabal-$(VERSION) $(KIND)'

# tags...

TAGSSRCDIRS = Distribution Language
tags TAGS: $(SOURCES)
	find $(TAGSSRCDIRS) -name \*.\*hs | xargs hasktags

=== libraries/Cabal/Cabal/doc/requirements.txt ===
sphinx == 3.1.*
sphinx_rtd_theme

=== libraries/base/tests/perf/Makefile ===
# This Makefile runs the tests using GHC's testsuite framework.  It
# assumes the package is part of a GHC build tree with the testsuite
# installed in ../../../testsuite.

TOP=../../../../testsuite
include $(TOP)/mk/boilerplate.mk
include $(TOP)/mk/test.mk


T17752:
	'$(TEST_HC)' $(TEST_HC_OPTS) -O --make T17752 -rtsopts -ddump-simpl -ddump-to-file -dsuppress-uniques -dsuppress-all
	# All occurences of elem should be optimized away.
	# For strings these should result in loops after inlining foldCString.
	# For lists it should result in a case expression.
	echo $$(cat T17752.dump-simpl | grep "elem" -A4 )

=== debian/changelog ===
ghc (9.0.2-5) unstable; urgency=medium

  * Team upload.
  * Fix FTBFS with sphinx 7.1 (Closes: #1042658)

 -- Scott Talbert <swt@techie.net>  Mon, 31 Jul 2023 18:47:27 -0400

ghc (9.0.2-4) unstable; urgency=medium

  * Backport patch to fix ABI reproducibility (Closes: #1015733)

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Sat, 24 Sep 2022 10:06:11 +0300

ghc (9.0.2-3) unstable; urgency=medium

  * Declare compliance with Debian policy 4.6.1
  * Separate the binary-all/binary-any builds (Closes: #1014066)

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Fri, 15 Jul 2022 17:03:35 +0300

ghc (9.0.2-2) unstable; urgency=medium

  * Upload to unstable.

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Tue, 21 Jun 2022 19:57:57 +0300

ghc (9.0.2-1exp1) experimental; urgency=medium

  * Cherry-pick two upstream changes to build with llvm-13 on arm*
    - debian/patches/78db231ffdf8385662812781c1d09c630cfad313.patch:
    - debian/patches/ddd2591c5ca395e39ea36855e5b7e0a3464b7ad8.patch:
  * Update to llvm-13 (Closes: #1000929)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 10 Jun 2022 15:39:19 +0200

ghc (9.0.2-1) unstable; urgency=medium

  * Upload to unstable.
  * Remove Joachim Breitner from uploaders.
  * Drop libncurses5-dev dep in favor of libncurses-dev (Closes: #998348).
  * Update to llvm-12 (Closes: #1000929).

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Fri, 10 Jun 2022 12:49:38 +0300

ghc (9.0.2-1~exp1) experimental; urgency=medium

  [ Gianfranco Costamagna ]
  * Revert last change on mipsel, didn't fix the failure

  [ Ilias Tsitsimpis ]
  * New upstream release.
  * Refresh patches.

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Fri, 03 Jun 2022 11:25:00 +0300

ghc (8.10.7-1~exp2) experimental; urgency=medium

  * Lower parallelism builds to 2 on mipsel

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 21 Jan 2022 11:20:56 +0100

ghc (8.10.7-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Add upstream GPG key used to sign the tarballs.
  * Drop patches applied upstream.
  * Refresh and re-enable 'fix-big-endian-ffi' patch.
  * Fix compilation on armel.
  * Fix linker relocation errors on mips64el.
  * Switch to unregistered build on i386 to avoid a baseline violation.
    Thanks to Adrian Bunk for the patch.

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Sun, 24 Oct 2021 15:03:50 +0300

ghc (8.10.6-1~exp4) experimental; urgency=medium

  * Drop some patches now upstream.
  * Add a patch from Fedora to avoid too much logs on s390x.
  * Enable unregisterised builds on s390x

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 26 Aug 2021 12:00:34 +0200

ghc (8.10.4-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 14 Feb 2021 11:02:03 +0100

ghc (8.10.3-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 24 Dec 2020 23:10:52 +0100

ghc (8.10.2-1~exp3) experimental; urgency=medium

  * Upload to experimental with changes from 8.8.4-2

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 23 Dec 2020 23:20:54 +0100

ghc (8.10.2-1~exp2) experimental; urgency=medium

  * Drop FFI patch, makes the package FTBFS everywhere

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 19 Aug 2020 21:32:42 +0200

ghc (8.10.2-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 18 Aug 2020 15:11:31 +0200

ghc (8.10.1-1~exp1) experimental; urgency=medium

  * New upstream release
  * Drop llvm-9 patch: upstream
  * Also reduce parallel builds on arm64

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 27 May 2020 17:46:58 +0200

ghc (8.8.4-3) unstable; urgency=medium

  * Disable parallel install to fix races with missing directories
    (Closes: #944493)
  * Fix FTBFS with autoconf 2.71. Thanks to Matthias Klose for the patch
    (Closes: #995036)
  * Fix FTBFS with Sphinx 4.2.0 (Closes: #995429)

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Sun, 03 Oct 2021 14:27:00 +0300

=== debian/control ===
Source: ghc
Section: haskell
Priority: optional
Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
Uploaders:
 Clint Adams <clint@debian.org>,
 Ilias Tsitsimpis <iliastsi@debian.org>
Standards-Version: 4.6.1
Rules-Requires-Root: no
Build-Depends:
  debhelper-compat (= 12),
  haskell-devscripts-minimal <!cross>,
  devscripts,
  grep-dctrl,
  pkg-config,
  ghc:native (>= 8.6),
  libgmp-dev,
  llvm-13 [arm64 armel armhf],
  libffi-dev,
  libncurses-dev,
  python3-sphinx <!cross>,
  python3-sphinx-rtd-theme <!cross>,
  dpkg-dev (>= 1.16.1.1)
Build-Depends-Indep:
  hscolour,
  fop
Build-Conflicts: ccache
Homepage: https://haskell.org/ghc/
Vcs-Git: https://salsa.debian.org/haskell-team/DHG_packages.git [p/ghc]
Vcs-Browser: https://salsa.debian.org/haskell-team/DHG_packages/tree/master/p/ghc

Package: ghc
Architecture: any
Depends:
  llvm-13 [arm64 armel armhf],
  gcc,
  libgmp-dev,
  libffi-dev,
  libbsd-dev,
  libc6-dev,
  libncurses-dev,
  ${shlibs:Depends},
  ${misc:Depends}
Pre-Depends: dpkg (>= 1.16.1)
Provides:
  haskell-compiler,
  ghc-dynamic,
  ${ghci},
  ${provided-devs},
  ${haskell:Provides},
  haddock,
  ghc-haddock,
  ${haddock:Provides}
Replaces: ghc6 (<< 7), ghc-dynamic (<< 7.8), ghc-haddock (<< 7.10), ${conflicting-devs}
Conflicts: ghc6 (<< 7), ghc-dynamic (<< 7.8)
Breaks: cabal-install (<< 1.22), haskell-devscripts (<< 0.8.13),
 ghc-doc (<< 7.10), ghc-haddock (<< 7.10), ${conflicting-devs}
Suggests: perl, ghc-prof, ghc-doc, haskell-doc, llvm-13
Description: The Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.

Package: ghc-prof
Architecture: any
Provides: ${provided-profs}, ${haskell:Provides}
Depends: ghc (= ${binary:Version}), ${misc:Depends}
Replaces: ghc6-prof (<< 7)
Conflicts: ghc6-prof (<< 7)
Description: Profiling libraries for the Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.
 .
 This package contains additional profiling libraries. They are only needed,
 if you want to take a closer look on where exactly your program burns CPU
 cycles.

Package: ghc-doc
Section: doc
Architecture: all
Suggests: haskell-doc
Provides: ${provided-docs}
Replaces: ghc6-doc (<< 7), libghc-terminfo-doc (<< 0.3.2.5-4), libghc-transformers-doc (<< 0.3.0.0-6), libghc-xhtml-doc (<< 3000.2.1-5)
Conflicts: ghc6-doc (<< 7), ghc (<= 7.0.3-1)
Breaks: libghc-terminfo-doc (<< 0.3.2.5-4), libghc-transformers-doc (<< 0.3.0.0-6), libghc-xhtml-doc (<< 3000.2.1-5)
Depends: ${haddock:Depends}, ${misc:Depends}, perl, libjs-mathjax
Pre-Depends: dpkg (>= 1.16.1)
Description: Documentation for the Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.
 .
 This package includes HTML, DVI and PS versions of the SGML-based
 documentation around GHC.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# This file is public domain software, originally written by Joey Hess.
#
# This version is for a multibinary package. It also allows you to build any
# of the binary packages independantly, via binary-<package> targets.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# # Set default flags with dpkg-buildflags
# # This might also close #712228
# export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# DPKG_EXPORT_BUILDFLAGS = 1
# include /usr/share/dpkg/buildflags.mk

# Set a dummy HOME variable upon build. Some build daemons do not set HOME, but
# ghc-cabal expects it to be available.
export HOME = /homedoesnotexistatbuildtime

# From /usr/share/doc/autotools-dev/examples/rules.gz:
export DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
export DEB_HOST_ARCH      ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
export DEB_TARGET_ARCH_ENDIAN	?= $(shell dpkg-architecture -qDEB_TARGET_ARCH_ENDIAN)

# We're cross-building if DEB_BUILD_GNU_TYPE != DEB_HOST_GNU_TYPE
ifneq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
  EXTRA_CONFIGURE_FLAGS += --host $(DEB_BUILD_GNU_TYPE) --build $(DEB_BUILD_GNU_TYPE) --target $(DEB_HOST_GNU_TYPE) --enable-unregisterised
  BUILD_CROSS=YES
else
  EXTRA_CONFIGURE_FLAGS += --target $(DEB_HOST_GNU_TYPE)
  BUILD_CROSS=NO
endif

ProjectVersion=$(shell cat VERSION)

export GHC=$(firstword $(shell bash -c "type -p ghc"))

DEB_HOOGLE_TXT_DIR = /usr/lib/ghc-doc/hoogle/

ifneq (,$(filter i386 powerpcspe x32 s390x, $(DEB_HOST_ARCH)))
  # From GHC 8.10 and later, native code generator support for legacy x87
  # floating point coprocessor has been removed. GHC now only support floating
  # point via SSE2. This causes a baseline violation on Debian for i386 where
  # there is no SSE support. Fallback to unregisterised builds on i386.
  EXTRA_CONFIGURE_FLAGS += --enable-unregisterised
endif

#ifeq (yes,$(shell dpkg-vendor --derives-from Ubuntu && echo yes))
#ifeq (armhf,$(DEB_HOST_ARCH))
#  # armhf on Ubuntu needs unregisterised due to performance issues during build.
#  EXTRA_CONFIGURE_FLAGS += --enable-unregisterised
#endif
#endif

# Use system's default ld (ld.bfd) rather than ld.gold, which fails for
# haskell-cryptohash-sha256 on mips/mipsel. For more information, see
# https://bugs.debian.org/901947
# NOTE: This should probably be removed, and revert back to using ld.gold,
# once #901947 has been fixed.
# Do the same for powerpcspe, due to https://bugs.debian.org/904915
# Do the same for sparc64, due to https://bugs.debian.org/908998
ifneq (,$(filter mips mipsel powerpc powerpcspe sparc64, $(DEB_HOST_ARCH)))
  EXTRA_CONFIGURE_FLAGS += --disable-ld-override
endif

%:
	dh $@

override_dh_autoreconf:
	dh_autoreconf perl -- boot

override_dh_auto_configure:
	echo "SRC_HC_OPTS += -lffi -optl-pthread" >> mk/build.mk
ifeq (NO,$(BUILD_CROSS))
	echo "CrossCompiling := NO" >> mk/build.mk
	echo "Stage1Only := NO" >> mk/build.mk
	echo "HADDOCK_DOCS := YES" >> mk/build.mk
	echo "EXTRA_HADDOCK_OPTS += --mathjax=file:///usr/share/javascript/mathjax/MathJax.js" >> mk/build.mk
	echo "XSLTPROC_OPTS += --nonet" >> mk/build.mk
else
	echo "CrossCompiling := YES" >> mk/build.mk
	echo "Stage1Only := NO" >> mk/build.mk
	echo "SRC_HC_OPTS += -O0 -H64m" >> mk/build.mk
	echo "GhcStage1HcOpts = -O" >> mk/build.mk
	echo "GhcStage2HcOpts = -O0" >> mk/build.mk
	echo "GhcLibHcOpts = -O" >> mk/build.mk
	echo "SplitObjs = NO" >> mk/build.mk
	echo "HADDOCK_DOCS := NO" >> mk/build.mk
	echo "BUILD_SPHINX_HTML := NO" >> mk/build.mk
	echo "BUILD_SPHINX_PDF := NO" >> mk/build.mk
endif
ifeq (armhf,$(DEB_HOST_ARCH))
	echo "SRC_HC_OPTS += -D__ARM_PCS_VFP" >> mk/build.mk
endif
ifeq (big, $(DEB_TARGET_ARCH_ENDIAN))
	# See https://gitlab.haskell.org/ghc/ghc/issues/16998
	patch -p1 < debian/patches/Disable-unboxed-arrays.patch
endif
ifneq (,$(filter powerpcspe x32 s390x, $(DEB_HOST_ARCH)))
	# From Fedora
	patch -p1 < debian/patches/ghc-warnings.mk-CC-Wall.patch
endif
ifneq (,$(filter i386 mips mipsel s390x, $(DEB_HOST_ARCH)))
	echo "SRC_HC_OPTS     += -optc--param -optcggc-min-expand=10" >> mk/build.mk
endif
ifneq (,$(filter mips64el, $(DEB_HOST_ARCH)))
	# Pass -mxgot to fix relocation linker errors
	echo "compiler/GHC/Hs/Instances_HC_OPTS += -optc-mxgot" >> mk/build.mk
endif
ifeq (x32,$(DEB_HOST_ARCH))
	echo "INTEGER_LIBRARY = integer-simple" >> mk/build.mk
endif
ifneq (,$(filter nostrip, $(DEB_BUILD_OPTIONS)))
#	echo "GhcStage1HcOpts += -DDEBUG" >> mk/build.mk
#	echo "GhcStage2HcOpts += -DDEBUG" >> mk/build.mk
	echo "SRC_HC_OPTS   += -H32m -O0" >> mk/build.mk
	echo "GhcHcOpts     += -Rghc-timing -DDEBUG" >> mk/build.mk
#	echo "GhcLibHcOpts  += -O -dcore-lint -keep-hc-files " >> mk/build.mk
	echo "SplitObjs     = NO" >> mk/build.mk
	echo "STRIP         = :" >> mk/build.mk
endif
ifneq (,$(filter noopt, $(DEB_BUILD_OPTIONS)))
	echo "SRC_HC_OPTS   += -H32m -O0" >> mk/build.mk
	echo "GhcHcOpts     += -O0" >> mk/build.mk
	# This breaks the build - to be investigated:
	# echo "GhcLibHcOpts  += -O0" >> mk/build.mk
	echo "GhcRtsCcOpts  += -O0" >> mk/build.mk
endif
ifneq (,$(filter alpha i386 m68k mipsel hppa sh4 x32, $(DEB_HOST_ARCH)))
	# Virtual memory exhausted when trying to build unregisterised compiler on
	# 32-bit targets. Disable optimizations for compiler/GHC/Hs/Instances.hs.
	# See https://bugs.debian.org/933968
	# See https://gitlab.haskell.org/ghc/ghc/issues/17048
	echo "compiler/GHC/Hs/Instances_HC_OPTS += -O0" >> mk/build.mk
endif
	# We also want to build the threaded profiling-enabled debug runtime,
	# because it does no harm
	echo 'GhcRTSWays += $$(if $$(filter p, $$(GhcLibWays)),thr_debug_p,)' >> mk/build.mk

	# We can't do this with a configure flag in 6.8.1 as libdir is not
	# defined at the point at which we := it
	echo 'ghclibdir := $${libdir}/ghc' >> mk/build.mk
	echo 'bindir  := /usr/bin' >> mk/build.mk
	# docdir doesn't have a configure flag, and unfortunately
	# we also need to explicitly define all of its dependents as they
	# are set with :=
	echo 'docdir  := $$(datarootdir)/doc/ghc-doc' >> mk/build.mk
	echo 'htmldir := $$(docdir)'                   >> mk/build.mk
	echo 'dvidir  := $$(docdir)'                   >> mk/build.mk
	echo 'pdfdir  := $$(docdir)'                   >> mk/build.mk
	echo 'psdir   := $$(docdir)'                   >> mk/build.mk
	echo 'STRIP_CMD = $(DEB_HOST_GNU_TYPE)-strip'  >> mk/build.mk
	echo 'RANLIB_CMD = $(DEB_HOST_GNU_TYPE)-ranlib'>> mk/build.mk
	# We want verbose builds
	echo 'V=1'                                     >> mk/build.mk
	dh_auto_configure -- \
		$(EXTRA_CONFIGURE_FLAGS) \
		--with-system-libffi --libdir=/usr/lib

override_dh_auto_build-indep:
	# Building docs needs a full build
	dh_auto_build -i -- all docs

override_dh_auto_test:
ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	# Do some very simple tests that the compiler actually works
	rm -rf debian/testghc
	mkdir debian/testghc
	echo 'main = putStrLn "Foo"' > debian/testghc/foo.hs
	inplace/bin/ghc-stage2 debian/testghc/foo.hs -o debian/testghc/foo
	[ "$$(debian/testghc/foo)" = "Foo" ]
	rm debian/testghc/*
	echo 'main = putStrLn "Foo"' > debian/testghc/foo.hs
	inplace/bin/ghc-stage2 debian/testghc/foo.hs -o debian/testghc/foo -O2
	[ "$$(debian/testghc/foo)" = "Foo" ]
	rm debian/testghc/*
	@printf "====BEGIN GHC INFO OUTPUT====\n"
	@inplace/bin/ghc-stage2 --info
	@printf "====END GHC INFO OUTPUT====\n"
endif

FILES = \( -type f -o -type l \)
PROF_FILE = \( -name "*.p_*" -o -name "lib*_p.a" \)

override_dh_auto_install-arch:
	# See https://bugs.debian.org/944493 for why we use --no-parallel.
	dh_auto_install --no-parallel

	# Remove the haddock.t files, they really should not be in the released
	# package (upstream #10410)
	find debian/tmp -name \*.haddock.t -delete

	# Generate lintian overrides
	mkdir -p debian/tmp/usr/share/lintian/overrides

## ghc 9.4.6

=== debian/changelog ===
ghc (9.4.6-1) unstable; urgency=medium

  * Upload to unstable (Closes: #1017663, #1039474)

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Fri, 25 Aug 2023 20:12:47 +0300

ghc (9.4.6-1~exp4) experimental; urgency=medium

  * Fallback to LLVM 15
  * Do not depend on LLVM for arm64, it now has a native codegen

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Sun, 20 Aug 2023 23:13:59 +0300

ghc (9.4.6-1~exp3) experimental; urgency=medium

  * Backport upstream patch to use old pass manager in LLVM

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Sun, 20 Aug 2023 15:33:14 +0300

ghc (9.4.6-1~exp2) experimental; urgency=medium

  * Use LLVM 16

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Sun, 20 Aug 2023 10:33:37 +0300

ghc (9.4.6-1~exp1) experimental; urgency=medium

  * New upstream release
  * Do not reduce parallelism on mipsel, as this doesn't fix OOM issues
  * Drop 'ghc-prim-libatomic' patch, doesn't work
  * Do not run inplace/bin/ghc-stage2 for cross-builds (Closes: #1042078)

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Fri, 11 Aug 2023 19:52:02 +0300

ghc (9.4.5-1~exp3) experimental; urgency=medium

  * Try to reduce parallel builds on mipsel

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 01 Aug 2023 09:23:09 +0200

ghc (9.4.5-1~exp2) experimental; urgency=medium

  * Re-introduce 'fix-llvm-armel' patch
  * Drop 'Disable-unboxed-arrays' patch, not needed any more
  * Build unregisterised on riscv64
  * Use libatomic in ghc-prim library

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Fri, 07 Jul 2023 19:12:19 +0300

ghc (9.4.5-1~exp1) experimental; urgency=medium

  [ Gianfranco Costamagna ]
  * Don't use llvm on riscv64, doesn't fix the build

  [ Ilias Tsitsimpis ]
  * New upstream release

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Sun, 02 Jul 2023 18:10:44 +0300

ghc (9.2.7-1~exp3) experimental; urgency=medium

  * debian/patches/5fe11fe612e1881bd4d1b9d5950d0d801e08e159.patch:
    - cherry-pick upstream patch to increase llvm upper bound to 15

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 20 Apr 2023 12:26:28 +0200

ghc (9.2.7-1~exp2) experimental; urgency=medium

  * Switch to llvm-14 and add riscv64 to llvm-* archs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 20 Apr 2023 09:51:25 +0200

ghc (9.2.7-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 16 Mar 2023 19:21:44 +0100

ghc (9.2.5-1~exp2) experimental; urgency=medium

  * build-fix-hs-constants.patch
    - cherry-pick upstream proposed fix for build failure.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 29 Nov 2022 14:35:58 +0100

ghc (9.2.5-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Drop patches now part of upstream codebase:
    - buildpath-abi-stability-2.patch
    - latomic-subword
    - latomic-64bit
  * Refresh patches

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 29 Nov 2022 10:29:14 +0100

=== debian/control ===
--- 
+++ 
@@ -13,9 +13,9 @@
   devscripts,
   grep-dctrl,
   pkg-config,
-  ghc:native (>= 8.6),
+  ghc:native (>= 9.0),
   libgmp-dev,
-  llvm-13 [arm64 armel armhf],
+  llvm-15 [armel armhf],
   libffi-dev,
   libncurses-dev,
   python3-sphinx <!cross>,
@@ -32,7 +32,7 @@
 Package: ghc
 Architecture: any
 Depends:
-  llvm-13 [arm64 armel armhf],
+  llvm-15 [armel armhf],
   gcc,
   libgmp-dev,
   libffi-dev,
@@ -55,7 +55,7 @@
 Conflicts: ghc6 (<< 7), ghc-dynamic (<< 7.8)
 Breaks: cabal-install (<< 1.22), haskell-devscripts (<< 0.8.13),
  ghc-doc (<< 7.10), ghc-haddock (<< 7.10), ${conflicting-devs}
-Suggests: perl, ghc-prof, ghc-doc, haskell-doc, llvm-13
+Suggests: perl, ghc-prof, ghc-doc, haskell-doc, llvm-15
 Description: The Glasgow Haskell Compilation system
  The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
  Haskell.

=== debian/rules ===
--- 
+++ 
@@ -39,20 +39,13 @@
 
 DEB_HOOGLE_TXT_DIR = /usr/lib/ghc-doc/hoogle/
 
-ifneq (,$(filter i386 powerpcspe x32 s390x, $(DEB_HOST_ARCH)))
+ifneq (,$(filter i386 powerpcspe x32 s390x riscv64, $(DEB_HOST_ARCH)))
   # From GHC 8.10 and later, native code generator support for legacy x87
   # floating point coprocessor has been removed. GHC now only support floating
   # point via SSE2. This causes a baseline violation on Debian for i386 where
   # there is no SSE support. Fallback to unregisterised builds on i386.
   EXTRA_CONFIGURE_FLAGS += --enable-unregisterised
 endif
-
-#ifeq (yes,$(shell dpkg-vendor --derives-from Ubuntu && echo yes))
-#ifeq (armhf,$(DEB_HOST_ARCH))
-#  # armhf on Ubuntu needs unregisterised due to performance issues during build.
-#  EXTRA_CONFIGURE_FLAGS += --enable-unregisterised
-#endif
-#endif
 
 # Use system's default ld (ld.bfd) rather than ld.gold, which fails for
 # haskell-cryptohash-sha256 on mips/mipsel. For more information, see
@@ -69,7 +62,7 @@
 	dh $@
 
 override_dh_autoreconf:
-	dh_autoreconf perl -- boot
+	dh_autoreconf ./boot.source
 
 override_dh_auto_configure:
 	echo "SRC_HC_OPTS += -lffi -optl-pthread" >> mk/build.mk
@@ -93,10 +86,6 @@
 endif
 ifeq (armhf,$(DEB_HOST_ARCH))
 	echo "SRC_HC_OPTS += -D__ARM_PCS_VFP" >> mk/build.mk
-endif
-ifeq (big, $(DEB_TARGET_ARCH_ENDIAN))
-	# See https://gitlab.haskell.org/ghc/ghc/issues/16998
-	patch -p1 < debian/patches/Disable-unboxed-arrays.patch
 endif
 ifneq (,$(filter powerpcspe x32 s390x, $(DEB_HOST_ARCH)))
 	# From Fedora
@@ -138,6 +127,13 @@
 	# We also want to build the threaded profiling-enabled debug runtime,
 	# because it does no harm
 	echo 'GhcRTSWays += $$(if $$(filter p, $$(GhcLibWays)),thr_debug_p,)' >> mk/build.mk
+
+	# The make build system is completely broken at this point, since it
+	# doesn't pass the '-build-tool-depends' flag (as Handrian does) and require
+	# alex/happy to build from a release tarball.
+	echo 'utils/genprimopcode_CONFIGURE_OPTS += "-f-build-tool-depends"' >> mk/build.mk
+	echo 'compiler_CONFIGURE_OPTS += "-f-build-tool-depends"' >> mk/build.mk
+	echo 'utils/hpc_CONFIGURE_OPTS += "-f-build-tool-depends"' >> mk/build.mk
 
 	# We can't do this with a configure flag in 6.8.1 as libdir is not
 	# defined at the point at which we := it
